# -*- coding: cp932 -*-
# YURAYURA.py

"""
g:

̃XNvgÂ܂܃VFto^ɏo܂B

vOCƂĎgpꍇ́AmayascriptstH_
̃t@C܂B
C:\\Users\[user]\Documents\maya\scripts
́APYTHON_PATHݒ肵ĂꏊłOKłB

sR}h
import YURAYURA;YURAYURA.YURAYURA()


̖тȂǂ̐qKwɃwAV~[Vc[łB

c[sUIオ܂B

GENERATE:
@̖т̃[gIāAGENERATE{^
@YURAYURAV~[VZbg܂B
@IłAx쐬łǉŎgpł܂B

MODIFY:
@SETTING̐lύXāAɂMODIFY SETTING ( REFRESH )
@{^œKpł܂B

COLLIDE:
@RWZbgꍇ́ARWIuWFNgI
@ADD COLLIDE{^܂B

BAKE:
@V~[Vʂǂł΁ABAKE{^
@ɑIĂKwׂĂRotateBake Simulation܂B
@YURAYURAV~[VZbg͏AUI܂B
"""


import pymel.core as pm

class YURAYURA:
    def __init__(self):
        print("================== YURAYURA ==================")
        self.root = self.getNode("YURAYURA") # root
        self.nc = self.getNode("YURAYURA_nucleus") # nucleus
        self.hs = self.getNode("YURAYURA_hairSystem") # hairSystem
        self.tm = pm.PyNode("time1") # timem[h

        # UIグ
        self.UI()
    
    # m[h擾
    def getNode(self,s):
        if pm.objExists("s"):
            self.root = pm.PyNode("s")
        else:
            self.root = None
        
    # nucleus
    def setNc(self):
        s = "YURAYURA_nucleus"
        if pm.objExists(s):
            self.nc = pm.PyNode(s)
        else:
            self.nc = pm.createNode("nucleus",n=s,p=self.root,ss=1)
            pm.mel.eval('$gActiveNucleusNode = "%s"'%s)
            self.tm.outTime >> self.nc.currentTime
    
    # hairSystem
    def setHs(self):
        s = "YURAYURA_hairSystem"
        if pm.objExists(s):
            self.hs = pm.PyNode(s)
        else:
            self.hs = pm.createNode("hairSystem",ss=1)
            self.hs.active.set(1)
            self.hs.getParent().rename(s)
            self.hs.getParent().setParent(self.root)
            self.tm.outTime >> self.hs.currentTime
            self.nc.outputObjects[0] >> self.hs.nextState;
            self.nc.startFrame >> self.hs.startFrame
            self.hs.currentState >> self.nc.inputActive[0]
            self.hs.startState >> self.nc.inputActiveStart[0]
            
    # Kw̃IuWFNgXgԂiqQȏ゠Ăŏ̂ЂƂj
    def getHie(self,obj,l=[]):
        l.append(obj)
        c = obj.listRelatives(typ="transform")
        if c:
            self.getHie(c[0],l)
        return l
    
    # IuWFNgXg烏[h|WVXgԂ
    def getPos(self,lobj):
        l = []
        for o in lobj:
            l.append(o.getTranslation(space="world"))
        return l
    
    # ݒXVIKĂȂȂoÔŃtbViikHandleړƃtbVj
    def ikRefresh(self):
        pm.move(0,0,0,self.root.listRelatives(ad=1,typ="ikHandle"))
        #pm.refresh(f=1)
        
    def generate(self):
        # I𖳂͏I
        if not len(pm.selected()):
            print("nothing selected")
            return
        
        print("generate YURAYURA")
        
        # Play Every Frame, Max Real-timeɂ
        pm.playbackOptions(e=1,ps=0,mps=1)
        
        # sOɃX^[gt[
        pm.currentTime(pm.Env().minTime)
        
        # IL[v
        sel = pm.selected()
        
        # J[uXg
        lcrvB = [] # Base
        lcrvS = [] # Simulated
        
        # BoneXg
        lj = []
        
        # YURAYURÃ[g쐬
        rootname = "YURAYURA"
        if pm.objExists(rootname):
            self.root = pm.PyNode(rootname)
        else:
            self.root = pm.createNode("transform",n=rootname,ss=1)
        
        # nucleusݒ
        self.setNc()
        # hairSystemݒ
        self.setHs()
        
        # bakepZbg쐬
        setname = "YURAYURA_bake"
        if pm.objExists(setname):
            self.bakeSet = pm.PyNode(setname)
        else:
            self.bakeSet = pm.createNode("objectSet",n=setname,ss=1)
        
        # Ajnhair̐em[h֘Atp
        danimRoot = {}
        
        for i in range(len(sel)):
            # AjRXggXtH[m[h쐬
            prt = sel[i].getParent()
            if not prt in danimRoot:
                animRoot = pm.createNode("transform",p=self.root,ss=1)
                animRoot.visibility.set(0)
                animRoot.rename("%s_YRYR_anim"%sel[i].name())
                danimRoot[prt] = animRoot
                if prt:
                    pm.parentConstraint(prt,animRoot)
            
            # VJointpXg
            lj.append([])
            # JointKweZbg
            p = danimRoot[prt]
            
            # IKwƓKwJointKw쐬
            for ih,h in enumerate(self.getHie(sel[i],[])):
                print(h)
                # bakepZbgɓ
                self.bakeSet.add(h)
                # ItZbggXtH[쐬
                ofs = pm.createNode("transform",p=p,ss=1)
                ofs.rename(h.name()+"_offset")
                # IĂ̂jointȂJoint Orient̃ItZbg
                if h.type() == "joint":
                    ofs.rx.set(h.jox.get())
                    ofs.ry.set(h.joy.get())
                    ofs.rz.set(h.joz.get())
                    #ofs.setTranslation(h.getTranslation())
                pm.delete(pm.pointConstraint(h,ofs))
                #else:
                #    ofs.tx.set(h.rpx.get())
                #    ofs.ty.set(h.rpy.get())
                #    ofs.tz.set(h.rpz.get())
                
                # V~[Vpjoint쐬
                j = pm.createNode("joint",p=ofs,ss=1)
                j.segmentScaleCompensate.set(0)
                j.rename(h.name()+"_j")
                lj[i].append(j)
                
                #j.setMatrix(h.getMatrix(worldSpace=True),worldSpace=True)
                pm.delete(pm.parentConstraint(h,j))
                
                if not h.rx.isLocked(): j.rx >> h.rx
                if not h.ry.isLocked(): j.ry >> h.ry
                if not h.rz.isLocked(): j.rz >> h.rz
            
                # قǍ͎̃[v̐eɂ
                p = j
            
            # [ǉ
            j = pm.createNode("joint",p=ofs.getParent(),ss=1)
            j.segmentScaleCompensate.set(0)
            j.rename(sel[i].name()+"_end")
            pm.delete(pm.parentConstraint(h,j))
            j.setTranslation(j.getTranslation()*2)
            j.setParent(p)
            lj[i].append(j)
            
            # x[XJ[u쐬
            self.lp = self.getPos(lj[i])
            crvB = pm.curve(ep=self.lp)
            crvB.rename(lj[i][0].name()+"Base")
            lcrvB.append(crvB)
            
            # wA쐬
            #pm.mel.eval('assignHairSystem %s;'%hs)
            pm.select(crvB,r=1)
            if self.hs:
                pm.select(self.hs,add=1)
            pm.mel.eval('makeCurvesDynamic 2 { "0", "0", "1", "1", "0"};')
            
            if pm.objExists("YURAYURA_hairSystemFollicles"):
                pm.parent("YURAYURA_hairSystemFollicles",self.root)
            if pm.objExists("YURAYURA_hairSystemOutputCurves"):
                pm.parent("YURAYURA_hairSystemOutputCurves",self.root)
            
            # follicleݒ
            flc = pm.PyNode("YURAYURA_hairSystemFollicles").listRelatives(ad=1,typ="follicle")[-1]
            flc.pointLock.set(1)
            flc.getParent().setParent(danimRoot[prt])
            
            # V~[VJ[u
            crvS = pm.PyNode("YURAYURA_hairSystemOutputCurves").listRelatives()[-1].getShape()
            lcrvS.append(crvS)
            
            # SplineIKJointɓKp
            ikh,ike = pm.ikHandle(c=lcrvS[i],sj=lj[i][0],ee=lj[i][-1],sol="ikSplineSolver",scv=0,pcv=0,ccv=0,snc=1)
            ikh.setParent(danimRoot[prt])
        
        # p[^xZbg
        self.modify()
        
        # I
        pm.select(cl=1)
    
    # l̕ύXXV
    def modify(self):
        print("MODIFY SETTING")
        # nucleusݒ
        self.setNc()
        # hairSystemݒ
        self.setHs()
        pm.currentTime(pm.Env().minTime)
        self.nc.startFrame.set(pm.Env().minTime+1)
        self.nc.gravity.set(self.gravity.getValue())
        self.hs.startCurveAttract.set(self.startCurveAttract.getValue())
        self.hs.attractionDamp.set(self.attractionDamp.getValue())
        self.hs.drag.set(self.drag.getValue())
        self.hs.tangentialDrag.set(self.tangentialDrag.getValue())
        self.hs.motionDrag.set(self.motionDrag.getValue())
        self.hs.damp.set(self.damp.getValue())
        self.hs.stretchDamp.set(self.stretchDamp.getValue())
        
        self.ikRefresh()
    
    # RWǉ
    def addCollide(self):
        print("ADD COLLIDE")
        # nucleusݒ
        self.setNc()
        # hairSystemݒ
        self.setHs()
        pm.mel.eval("makeCollideNCloth;")
        pm.parent(set(self.nc.listConnections(t="nRigid")),"YURAYURA")
        
        self.ikRefresh()
    
    # bake@V~[VKwUI폜
    def bake(self):
        print("BAKE")
        pm.bakeResults(
            self.bakeSet.members(),
            sm=1,
            at=["rx","ry","rz"],
            t=[pm.Env().minTime,pm.Env().maxTime]
            )
        pm.delete(self.root,self.bakeSet)
        pm.deleteUI("YURAYURA",wnd=True)
                
    def UI(self):
        windowName = "YURAYURA"
        # EBhEsOɂ폜
        if pm.window(windowName, ex=1): pm.deleteUI(windowName)
        # UI쐬
        with pm.window(windowName,t=windowName,tlb=1):
            with pm.frameLayout(l="GENERATE:",bgc=[0.32,0.32,0.32]):
                pm.button(l="GENERATE",c=pm.Callback(self.generate))
            with pm.frameLayout(l="SETTING:",bgc=[0.32,0.32,0.32]):
                self.gravity = pm.floatSliderGrp("gravity",l="Gravity:",field=True,min=0,max=100,fmn=-10000,fmx=10000,step=0.01,value=9.81)
                self.startCurveAttract = pm.floatSliderGrp("startCurveAttract",l="Start Curve Attract:",field=True,min=0,max=1,fmn=-10000,fmx=10000,step=0.01,value=0.2)
                self.attractionDamp = pm.floatSliderGrp("attractionDamp",l="Attraction Damp:",field=True,min=0,max=1,fmn=-10000,fmx=10000,step=0.01,value=0.1)
                self.drag = pm.floatSliderGrp("drag",l="Drag:",field=True,min=0,max=1,fmn=-10000,fmx=10000,step=0.01,value=0.05)
                self.tangentialDrag = pm.floatSliderGrp("tangentialDrag",l="Tangential Drag:",field=True,min=0,max=1,fmn=-10000,fmx=10000,step=0.01,value=0.1)
                self.motionDrag = pm.floatSliderGrp("motionDrag",l="Motion Drag:",field=True,min=0,max=1,fmn=-10000,fmx=10000,step=0.01,value=0.01)
                self.damp = pm.floatSliderGrp("damp",l="Damp:",field=True,min=0,max=1,fmn=-10000,fmx=10000,step=0.01,value=0.01)
                self.stretchDamp = pm.floatSliderGrp("stretchDamp",l="Stretch Damp:",field=True,min=0,max=1,fmn=-10000,fmx=10000,step=0.01,value=0.1)
            with pm.frameLayout(l="MODIFY:",bgc=[0.32,0.32,0.32]):
                pm.button(l="MODIFY SETTING ( REFRESH )",c=pm.Callback(self.modify))
            with pm.frameLayout(l="COLLIDE:",bgc=[0.32,0.32,0.32]):
                pm.button(l="ADD COLLIDE",c=pm.Callback(self.addCollide))
            with pm.frameLayout(l="BAKE:",bgc=[0.32,0.32,0.32]):
                pm.button(l="BAKE",c=pm.Callback(self.bake))
    
#if __name__ == "__main__":
YURAYURA()
